OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::FileOutputStream Class Reference

`#include <juce_FileOutputStream.h>`

Inheritance diagram for juce::FileOutputStream:

## Public Member Functions
| FileOutputStream (const File &fileToWriteTo, size_t bufferSizeToUse=16384)
| ~FileOutputStream () override
const File & | getFile () const
const Result & | getStatus () const noexcept
bool | failedToOpen () const noexcept
bool | openedOk () const noexcept
Result | truncate ()
void | flush () override
int64 | getPosition () override
bool | setPosition (int64) override
bool | write (const void *, size_t) override
bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat) override
Public Member Functions inherited from juce::OutputStream
virtual | ~OutputStream ()
virtual void | flush ()=0
virtual bool | setPosition (int64 newPosition)=0
virtual int64 | getPosition ()=0
virtual bool | write (const void *dataToWrite, size_t numberOfBytes)=0
virtual bool | writeByte (char byte)
virtual bool | writeBool (bool boolValue)
virtual bool | writeShort (short value)
virtual bool | writeShortBigEndian (short value)
virtual bool | writeInt (int value)
virtual bool | writeIntBigEndian (int value)
virtual bool | writeInt64 (int64 value)
virtual bool | writeInt64BigEndian (int64 value)
virtual bool | writeFloat (float value)
virtual bool | writeFloatBigEndian (float value)
virtual bool | writeDouble (double value)
virtual bool | writeDoubleBigEndian (double value)
virtual bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat)
virtual bool | writeCompressedInt (int value)
virtual bool | writeString (const String &text)
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
void | setNewLineString (const String &newLineString)
const String & | getNewLineString () const noexcept

## Detailed Description

An output stream that writes into a local file.

See also
  OutputStream, FileInputStream, File::createOutputStream

Definition at line 34 of file juce_FileOutputStream.h.

## Constructor & Destructor Documentation

## ◆ FileOutputStream()

juce::FileOutputStream::FileOutputStream | ( | const File & | fileToWriteTo,
|  | size_t | bufferSizeToUse = `16384`
| ) |  |

Creates a FileOutputStream.

If the file doesn't exist, it will first be created. If the file can't be created or opened (for example, because the parent directory of the file does not exist), the failedToOpen() method will return true.

If the file already exists when opened, the stream's write-position will be set to the end of the file. To overwrite an existing file, you can truncate it like this:

FileOutputStream stream (file);
if (stream.openedOk())
{
stream.setPosition (0);
stream.truncate();
...
}
juce::FileOutputStream
Definition: juce_FileOutputStream.h:35

Destroying a FileOutputStream object does not force the operating system to write the buffered data to disk immediately. If this is required you should call flush() before triggering the destructor.

See also
  TemporaryFile

Definition at line 29 of file juce_FileOutputStream.cpp.

## ◆ ~FileOutputStream()

juce::FileOutputStream::~FileOutputStream | ( |  | ) |
| override

Destructor.

Definition at line 37 of file juce_FileOutputStream.cpp.

## Member Function Documentation

## ◆ failedToOpen()

bool juce::FileOutputStream::failedToOpen | ( |  | ) | const
| inline noexcept

Returns true if the stream couldn't be opened for some reason.

See also
  getResult()

Definition at line 86 of file juce_FileOutputStream.h.

Referenced by juce::File::appendText(), and juce::ZipFile::uncompressEntry().

## ◆ flush()

void juce::FileOutputStream::flush | ( |  | ) |
| override virtual

If the stream is using a buffer, this will ensure it gets written out to the destination.

Implements juce::OutputStream.

Definition at line 72 of file juce_FileOutputStream.cpp.

Referenced by juce::XmlElement::writeTo().

## ◆ getFile()

const File & juce::FileOutputStream::getFile | ( |  | ) | const
| inline

Returns the file that this stream is writing to.

Definition at line 75 of file juce_FileOutputStream.h.

## ◆ getPosition()

int64 juce::FileOutputStream::getPosition | ( |  | ) |
| override virtual

Returns the stream's current position.

See also
  setPosition

Implements juce::OutputStream.

Definition at line 43 of file juce_FileOutputStream.cpp.

## ◆ getStatus()

const Result & juce::FileOutputStream::getStatus | ( |  | ) | const
| inline noexcept

Returns the status of the file stream. The result will be ok if the file opened successfully. If an error occurs while opening or writing to the file, this will contain an error message.

Definition at line 81 of file juce_FileOutputStream.h.

Referenced by juce::File::create(), and juce::XmlElement::writeTo().

## ◆ openedOk()

bool juce::FileOutputStream::openedOk | ( |  | ) | const
| inline noexcept

Returns true if the stream opened without problems.

See also
  getResult()

Definition at line 91 of file juce_FileOutputStream.h.

Referenced by juce::File::appendData(), juce::WavAudioFormat::replaceMetadataInFile(), juce::FileLogger::trimFileSize(), write(), and juce::XmlElement::writeTo().

## ◆ setPosition()

bool juce::FileOutputStream::setPosition | ( | int64 | newPosition | ) |
| override virtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implements juce::OutputStream.

Definition at line 48 of file juce_FileOutputStream.cpp.

Referenced by juce::WavAudioFormat::replaceMetadataInFile().

## ◆ truncate()

Result juce::FileOutputStream::truncate | ( |  | ) |

Attempts to truncate the file to the current write position. To truncate a file to a specific size, first use setPosition() to seek to the appropriate location, and then call this method.

## ◆ write()

bool juce::FileOutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes
| ) |  |
| override virtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implements juce::OutputStream.

Definition at line 78 of file juce_FileOutputStream.cpp.

Referenced by juce::File::appendData().

## ◆ writeRepeatedByte()

bool juce::FileOutputStream::writeRepeatedByte | ( | uint8 | byte,
|  | size_t | numTimesToRepeat
| ) |  |
| override virtual

Writes a byte to the output stream a given number of times.

Returns
  false if the write operation fails for some reason

Reimplemented from juce::OutputStream.

Definition at line 117 of file juce_FileOutputStream.cpp.

The documentation for this class was generated from the following files:

- juce_FileOutputStream.h
- juce_FileOutputStream.cpp